#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       mythtvfr-verif.py
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.


import os, grp, MySQLdb
from xml.etree.ElementTree import ElementTree

user = os.environ['USER']
mythtvgrp = grp.getgrnam('mythtv')
configxml = '~/.mythtv/config.xml'
etcconfigxml = '/etc/mythtv/config.xml'

ok = "  -> \033[42m ok \033[0m" #ok en vert
ko = "  -> \033[41m ko \033[0m" #ko en rouge

configxml = os.path.expanduser(configxml)
etcconfigxml = os.path.expanduser(etcconfigxml)

ET = ElementTree()

error = None

# Vérif de groupe
print '%s fait parti du groupe mythtv ?'%user
if user in mythtvgrp.gr_mem :
    print ok
else :
    print ko
    error = True

#Vérif connection SQL avec ~/.mythtv/mysql.txt
print 'Test de connection MySQL avec "%s"'%configxml
if os.path.exists(configxml) :
    DBconfig = {}
    for element in ET.parse(configxml).find("UPnP/MythFrontend/DefaultBackend").iter() :
        DBconfig[element.tag] = element.text
    print "     connection à %(DBName)s (%(DBUserName)s@%(DBHostName)s) ..."%DBconfig
    try :
        dbsql=MySQLdb.connect(host=DBconfig['DBHostName'],user=DBconfig['DBUserName'],passwd=DBconfig['DBPassword'],db=DBconfig['DBName'])
        print ok
        dbsql.close()
    except MySQLdb.Error, e :
        print ko,"%d: %s" % (e.args[0], e.args[1])
        error = True
else :
    print ko,"fichier %s non trouvé"%mysqltxt


if error :
    print 'Test de connection MySQL avec "%s"'%etcconfigxml
    if os.path.exists(etcconfigxml) :
        DBconfig = {}
        for element in ET.parse(etcconfigxml).find("UPnP/MythFrontend/DefaultBackend").iter() :
            DBconfig[element.tag] = element.text
        print "     connection à %(DBName)s (%(DBUserName)s@%(DBHostName)s) ..."%DBconfig
        try :
            dbsql=MySQLdb.connect(host=DBconfig['DBHostName'],user=DBconfig['DBUserName'],passwd=DBconfig['DBPassword'],db=DBconfig['DBName'])
            print ok
            dbsql.close()
        except MySQLdb.Error, e :
            print ko,"%d: %s" % (e.args[0], e.args[1])
    else :
        print "  -> fichier non trouvé"

if error :
    exit(1)
else :
    print "Le paramétrage de MythTV semble correct"
    exit(0)
